<?php
// config check
ob_start();
require "config/config.php";
$config_content = ob_get_contents();
ob_end_clean();
// attributes check
ob_start();
chdir('config');
require "attributes.php";
chdir('../');
$attributes_content = ob_get_contents();
ob_end_clean();

$error_occured = false;
?>
<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Galaxytool installation program for version <?php echo VERSION; ?></title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" href="secret/styles.css" />
</head>
<body>
<?php
if (!isset($_GET['action']) || $_GET['action'] != "install") {
?>
<form action="index.php" method="GET">
<table class="standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">
<tr class="firstcolor"><td colspan="2" align="center" class="tblhead">Galaxytool <?php echo VERSION; ?> - Installation check</td></tr>
<?php
if ($config_content != "") {
	echo "content: |".utf8_encode($config_content)."|";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"success\">success</td></tr>\n";
}
if (!empty($attributes_content)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"success\">success</td></tr>\n";
}
if (empty($owner)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"success\">$owner</td></tr>\n";
}
if (empty($default_language)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"success\">$default_language</td></tr>\n";
}
if (empty($global_universe) || (!is_numeric($global_universe) && preg_replace("/[a-zA-Z0-9_\-]/","",$global_universe) != "" )) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"success\">$global_universe</td></tr>\n";
}
if (!is_numeric($speed_rate) || $speed_rate <= 0) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"failure\">failed</td></tr>\n";
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"success\">$speed_rate</td></tr>\n";
}
$link = mysql_connect($dbhost, $dbusername, $dbpassword);
if (!$link) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"success\">success</td></tr>\n";
	$db_selected = mysql_select_db($dbname, $link);
	if (!$db_selected) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"success\">success</td></tr>\n";

		$query = "SELECT VERSION() as version";
		$res = mysql_query($query) or die(mysql_error());
		$version = mysql_fetch_object($res);
		if (strpos($version->version,"-") > 0) {
			$version = substr($version->version,0,strpos($version->version,"-"));
		} else {
			$version = $version->version;
		}

		$subversion = explode(".",$version);
		if (!isset($subversion[0]) || $subversion[0] < 5) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
		} else {
			/*if ($subversion[0] == 4) {
			// MySQL 4.x.x
			if (!isset($subversion[1]) || $subversion[1] < 1) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
			} else {
			if (!isset($subversion[2]) || $subversion[2] < 16) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
			} else {
			// success
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
			}
			} else*/if ($subversion[0] == 5) {
			// MySQL 5.x.x
			// http://bugs.galaxytool.eu/view.php?id=375 <-- v5.0.87 has a bug
			if (!isset($subversion[1]) || !isset($subversion[2]) || ($subversion[1] == 0 && $subversion[2] < 16) || ($subversion[1] == 0 && $subversion[2] == 87)) {
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
				$error_occured = true;
			} else {
				// success
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
			} elseif ($subversion[0] == 6) {
				// MySQL 6.x.x
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
		}
	}
}
if (substr(phpversion(),0,1) > 4) {
	$version = substr(phpversion(),0,strpos(phpversion(), '-'));
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"success\">$version</td></tr>\n";
} else {
	$error_occured = true;
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"failure\">failed</td></tr>\n";
}

$db_tablenames = array();
array_push($db_tablenames,$dbtablename);
array_push($db_tablenames,$utablename);
array_push($db_tablenames,$playertable);
array_push($db_tablenames,$allytable);
array_push($db_tablenames,$noticetable);
array_push($db_tablenames,$reporttable);
array_push($db_tablenames,$iptablename);
array_push($db_tablenames,$shouttable);
array_push($db_tablenames,$allyhistory);
array_push($db_tablenames,$playerhistory);

$tablename_error = false;
foreach($db_tablenames as $tablename) {
	// check tablenames
	$tempname = preg_replace("/[^0-9a-z\_]/i","",$tablename);
	if (empty($tablename) || strlen($tablename) > 64 || $tempname != $tablename) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Tablename: '$tablename'</td><td class=\"failure\">failed</td></tr>\n";
		$tablename_error = true;
	}
}
if ($tablename_error === false) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Tablenames</td><td class=\"success\">success</td></tr>\n";
}

?>
<tr class="firstcolor"><td colspan="2">&nbsp;</td></tr>
<?php
if (!$error_occured) {
	echo "<tr class=\"firstcolor\"><td colspan=\"2\" align=\"center\"><a class=\"link\" href=\"install.php?action=install\">Install</a></td></tr>\n";
} else {
	echo "<tr class=\"firstcolor\"><td colspan=\"2\" align=\"center\"><a class=\"link\" href=\"install.php\">Check again</a></td></tr>\n";
}

} else {
	echo '<table class="standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">';

	mysql_connect($dbhost,$dbusername,$dbpassword) or die(mysql_error());
	mysql_select_db($dbname) or die(mysql_error());

	// send feedback - do not stop if this fails
	/*
	about the feedback:
	I collect information about the used MySQL version and PHP Version.
	I am using this information to know which versions I can skip.
	E.g. if only php5 would be used, I could use the php5 class system.
	If MySQL 5 or above would be used, I could use new MySQL 5 features.
	*/
	$query = "SELECT VERSION() as version";
	$res = mysql_query($query) or die(mysql_error());
	$version = mysql_fetch_object($res);
	$version = $version->version;
	$fp = @fopen("http://www.galaxytool.eu/feedback.php?php_version=".substr(phpversion(),0,strpos(phpversion(), '-'))."&mysql_version=".substr($version,0,strpos($version, '-')),"r");
	@fclose($fp);

	// start installation

	// Tabelle fuer die Galaxieansichten
	$query = "CREATE TABLE ".$dbtablename." (
			  galaxy int(2) NOT NULL default '0',
			  system int(3) NOT NULL default '0',
			  planet int(2) NOT NULL default '0',
			  player_id int(10) unsigned NOT NULL default '0',
			  moon enum('true','false') NOT NULL default 'false',
			  moonsize smallint(5) unsigned NOT NULL default '0',
			  metal int(10) unsigned NOT NULL default '0',
			  crystal int(10) unsigned NOT NULL default '0',
			  planetname varchar(40) NOT NULL default '',
			  last_update datetime NOT NULL default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  PRIMARY KEY  (galaxy,system,planet),
			  KEY player_id (player_id),
			  KEY moon (moon),
			  KEY last_update (last_update),
			  KEY metal (metal),
			  KEY crystal (crystal)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: galaxy</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: galaxy</td><td class=\"success\">success</td></tr>\n";
	}

	// Tabelle fuer die Benutzerverwaltung
	$query = "CREATE TABLE $utablename (
			  id smallint(10) unsigned NOT NULL auto_increment,
			  username varchar(40) NOT NULL default '',
			  userpass varchar(32) NOT NULL default '',
			  ogame_playerid int(11) unsigned NOT NULL default '0',
			  new_password enum('true','false') NOT NULL default 'true',
			  email varchar(50) NOT NULL default '',
			  ingame varchar(40) NOT NULL default '',
			  allytag varchar(40) NOT NULL default '',
			  timezone_offset varchar(6) NOT NULL default '+00:00',
			  stylepath varchar(255) NOT NULL default '',
			  is_admin enum('true','false') NOT NULL default 'false',
			  cansearch enum('true','false') NOT NULL default 'false',
			  caninsert enum('true','false') NOT NULL default 'false',
			  statusview enum('true','false') NOT NULL default 'false',
			  probeview enum('true','false') NOT NULL default 'false',
			  userman enum('true','false') NOT NULL default 'false',
			  allyhistory enum('true','false') NOT NULL default 'false',
			  diplomatic enum('true','false') NOT NULL default 'false',
			  status enum('email','admin','active') NOT NULL default 'email',
			  logins smallint(5) unsigned NOT NULL default '0',
			  lastlogin datetime NOT NULL default '0000-00-00 00:00:00',
			  last_action datetime NOT NULL default '0000-00-00 00:00:00',
			  statspage mediumint(8) unsigned NOT NULL default '100',
			  links text NOT NULL,
			  bb_coordinates varchar(25) NOT NULL default 'deeppink',
			  bb_moon varchar(25) NOT NULL default 'burlywood',
			  bb_debris varchar(25) NOT NULL default 'firebrick',
			  bb_ally varchar(25) NOT NULL default 'tomato',
			  bb_allydetails varchar(25) NOT NULL default 'coral',
			  bb_playername varchar(25) NOT NULL default 'teal',
			  bb_banned varchar(25) NOT NULL default 'red',
			  bb_vacation varchar(25) NOT NULL default 'skyblue',
			  bb_noob varchar(25) NOT NULL default 'limegreen',
			  bb_inactive varchar(25) NOT NULL default 'silver',
			  bb_longinactive varchar(25) NOT NULL default 'silver',
			  session_save text NOT NULL,
			  PRIMARY KEY  (id),
			  UNIQUE KEY username (username),
			  KEY last_action (last_action),
			  KEY ingame (ingame),
			  KEY ogame_playerid (ogame_playerid),
			  KEY is_admin (is_admin)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: usertable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: usertable</td><td class=\"success\">success</td></tr>\n";
	}

	// Adminuser eintragen
	$query = "INSERT INTO $utablename
		  (id, username, userpass, stylepath, is_admin, cansearch, caninsert, statusview, probeview, userman, allyhistory, diplomatic, status, links, session_save) VALUES
		  (1, 'admin', md5('galatool'),'styles.css', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'active', 'Galaxytool;http://www.galaxytool.eu', '')";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Creating Adminuser</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Creating Adminuser</td><td class=\"success\">success</td></tr>\n";
	}

	// Spielertabelle
	$query = "CREATE TABLE $playertable (
			  id int(10) unsigned NOT NULL auto_increment,
			  playername varchar(40) NOT NULL default '',
			  ogame_playerid int(11) unsigned default NULL,
			  alliance_id int(10) unsigned NOT NULL default '0',
			  rank smallint(5) unsigned NOT NULL default '0',
			  points int(10) unsigned NOT NULL default '0',
			  frank smallint(5) unsigned NOT NULL default '0',
			  fpoints int(10) unsigned NOT NULL default '0',
			  rrank smallint(5) unsigned NOT NULL default '0',
			  rpoints int(10) unsigned NOT NULL default '0',
			  last_stats_update datetime NOT NULL default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  homegalaxy int(2) NOT NULL default '0',
			  homesystem int(3) NOT NULL default '0',
			  homeplanet int(2) NOT NULL default '0',
			  noob enum('true','false') NOT NULL default 'false',
			  banned enum('true','false') NOT NULL default 'false',
			  vacation enum('true','false') NOT NULL default 'false',
			  inactive enum('true','false') NOT NULL default 'false',
			  long_inactive enum('true','false') NOT NULL default 'false',
			  diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') NOT NULL default 'nothing',
			  spiolvl tinyint(3) unsigned NOT NULL default '0',
			  computech tinyint(3) unsigned NOT NULL default '0',
			  waffentech tinyint(3) unsigned NOT NULL default '0',
			  schildtech tinyint(3) unsigned NOT NULL default '0',
			  rpz tinyint(3) unsigned NOT NULL default '0',
			  energytech tinyint(3) unsigned NOT NULL default '0',
			  hypertech tinyint(3) unsigned NOT NULL default '0',
			  vbt tinyint(3) unsigned NOT NULL default '0',
			  impulse tinyint(3) unsigned NOT NULL default '0',
			  hra tinyint(3) unsigned NOT NULL default '0',
			  lasertech tinyint(3) unsigned NOT NULL default '0',
			  iontech tinyint(3) unsigned NOT NULL default '0',
			  plasmatech tinyint(3) unsigned NOT NULL default '0',
			  forschungsnetz tinyint(3) unsigned NOT NULL default '0',
			  expedition tinyint(3) unsigned NOT NULL default '0',
			  gravi tinyint(3) unsigned NOT NULL default '0',
			  last_tech_update datetime NOT NULL default '0000-00-00 00:00:00',
			  PRIMARY KEY  (id),
			  UNIQUE KEY ogame_playerid (ogame_playerid),
			  KEY alliance_id (alliance_id),
			  KEY noob (noob),
			  KEY banned (banned),
			  KEY vacation (vacation),
			  KEY inactive (inactive),
			  KEY playername (playername),
			  KEY rank (rank),
			  KEY frank (frank),
			  KEY last_stats_update (last_stats_update),
			  KEY diplomatic_status (diplomatic_status)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playertable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playertable</td><td class=\"success\">success</td></tr>\n";
	}

	// Allytabelle
	$query = "CREATE TABLE $allytable (
			  id int(10) unsigned NOT NULL auto_increment,
			  ogame_allyid int(11) unsigned default NULL,
			  allyname varchar(40) default NULL,
			  rank smallint(5) unsigned NOT NULL default '0',
			  points int(10) unsigned NOT NULL default '0',
			  frank smallint(5) unsigned NOT NULL default '0',
			  fpoints int(10) unsigned NOT NULL default '0',
			  rrank smallint(5) unsigned NOT NULL default '0',
			  rpoints int(10) unsigned NOT NULL default '0',
			  members smallint(5) unsigned NOT NULL default '0',
			  diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') default 'nothing',
			  last_update datetime default '0000-00-00 00:00:00',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  PRIMARY KEY  (id),
			  UNIQUE KEY ogame_allyid (ogame_allyid),
			  KEY allyname (allyname),
			  KEY last_update (last_update),
			  KEY diplomatic_status (diplomatic_status),
			  KEY rank (rank)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allytable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allytable</td><td class=\"success\">success</td></tr>\n";
	}

	// Notiztabelle
	$query = "CREATE TABLE $noticetable (
              id int(11) NOT NULL auto_increment,
              noticetext text NOT NULL,
              player_id int(10) unsigned NOT NULL default '0',
              last_update datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              UNIQUE KEY player_id (player_id)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: noticetable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: noticetable</td><td class=\"success\">success</td></tr>\n";
	}

	// Reporttabelle
	$query = "CREATE TABLE $reporttable (
			  id int(10) unsigned NOT NULL auto_increment,
			  galaxy int(2) unsigned NOT NULL default '0',
			  system int(3) unsigned NOT NULL default '0',
			  planet int(2) unsigned NOT NULL default '0',
			  planetname varchar(40) NOT NULL default '',
			  moon enum('true','false') NOT NULL default 'false',
			  metal int(10) unsigned NOT NULL default '0',
			  crystal int(10) unsigned NOT NULL default '0',
			  deuterium int(10) unsigned NOT NULL default '0',
			  energy int(10) unsigned NOT NULL default '0',
			  kt mediumint(8) unsigned NOT NULL default '0',
			  gt mediumint(8) unsigned NOT NULL default '0',
			  lj mediumint(8) unsigned NOT NULL default '0',
			  sj mediumint(8) unsigned NOT NULL default '0',
			  krz mediumint(8) unsigned NOT NULL default '0',
			  ss mediumint(8) unsigned NOT NULL default '0',
			  kolo mediumint(8) unsigned NOT NULL default '0',
			  rec mediumint(8) unsigned NOT NULL default '0',
			  spio mediumint(8) unsigned NOT NULL default '0',
			  bomb mediumint(8) unsigned NOT NULL default '0',
			  zerri mediumint(8) unsigned NOT NULL default '0',
			  ds mediumint(8) unsigned NOT NULL default '0',
			  skrz mediumint(8) unsigned NOT NULL default '0',
			  sat mediumint(8) unsigned NOT NULL default '0',
			  rak mediumint(8) unsigned NOT NULL default '0',
			  ll mediumint(8) unsigned NOT NULL default '0',
			  sl mediumint(8) unsigned NOT NULL default '0',
			  ion mediumint(8) unsigned NOT NULL default '0',
			  gauss mediumint(8) unsigned NOT NULL default '0',
			  plasma mediumint(8) unsigned NOT NULL default '0',
			  ksk mediumint(8) unsigned NOT NULL default '0',
			  gsk mediumint(8) unsigned NOT NULL default '0',
			  arak mediumint(8) unsigned NOT NULL default '0',
			  irak mediumint(8) unsigned NOT NULL default '0',
			  memi tinyint(3) unsigned NOT NULL default '0',
			  krimi tinyint(3) unsigned NOT NULL default '0',
			  deutsyn tinyint(3) unsigned NOT NULL default '0',
			  solar tinyint(3) unsigned NOT NULL default '0',
			  fusion tinyint(3) unsigned NOT NULL default '0',
			  robo tinyint(3) unsigned NOT NULL default '0',
			  nani tinyint(3) unsigned NOT NULL default '0',
			  rawe tinyint(3) unsigned NOT NULL default '0',
			  mesp tinyint(3) unsigned NOT NULL default '0',
			  krissp tinyint(3) unsigned NOT NULL default '0',
			  deutsp tinyint(3) unsigned NOT NULL default '0',
			  folab tinyint(3) unsigned NOT NULL default '0',
			  terra tinyint(3) unsigned NOT NULL default '0',
			  allydep tinyint(3) unsigned NOT NULL default '0',
			  raksilo tinyint(3) unsigned NOT NULL default '0',
			  mbase tinyint(3) unsigned NOT NULL default '0',
			  sensor tinyint(3) unsigned NOT NULL default '0',
			  sprungtor tinyint(3) unsigned NOT NULL default '0',
			  spiolvl tinyint(3) unsigned NOT NULL default '0',
			  computech tinyint(3) unsigned NOT NULL default '0',
			  waffentech tinyint(3) unsigned NOT NULL default '0',
			  schildtech tinyint(3) unsigned NOT NULL default '0',
			  rpz tinyint(3) unsigned NOT NULL default '0',
			  energytech tinyint(3) unsigned NOT NULL default '0',
			  hypertech tinyint(3) unsigned NOT NULL default '0',
			  vbt tinyint(3) unsigned NOT NULL default '0',
			  impulse tinyint(3) unsigned NOT NULL default '0',
			  hra tinyint(3) unsigned NOT NULL default '0',
			  lasertech tinyint(3) unsigned NOT NULL default '0',
			  iontech tinyint(3) unsigned NOT NULL default '0',
			  plasmatech tinyint(3) unsigned NOT NULL default '0',
			  forschungsnetz tinyint(3) unsigned NOT NULL default '0',
			  expedition tinyint(3) unsigned NOT NULL default '0' COMMENT 'Expedition technology',
			  gravi tinyint(3) unsigned NOT NULL default '0',
			  fleet_resis bigint(20) unsigned NOT NULL default '0',
			  defence_resis bigint(20) unsigned NOT NULL default '0',
			  scantime varchar(19) NOT NULL default '',
			  user_id smallint(5) unsigned NOT NULL default '0',
			  scanned enum('ressources','fleet','defence','buildings','research') NOT NULL default 'ressources',
			  min_phalanx int(3) unsigned default NULL,
			  max_phalanx int(3) unsigned default NULL,
			  min_rak int(3) unsigned default NULL,
			  max_rak int(3) unsigned default NULL,
			  PRIMARY KEY  (id),
			  UNIQUE KEY coordinates (galaxy,system,planet,moon),
			  KEY scantime (scantime),
			  KEY metal (metal),
			  KEY crystal (crystal),
			  KEY deuterium (deuterium),
			  KEY min_rak (galaxy,min_rak),
			  KEY min_phalanx (galaxy,min_phalanx),
			  KEY user_id (user_id)
           ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reporttable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: reporttable</td><td class=\"success\">success</td></tr>\n";
	}

	// IP Tabelle
	$query = "CREATE TABLE $iptablename (
              id int(10) unsigned NOT NULL auto_increment,
              userid smallint(5) unsigned NOT NULL default '0',
              ip varchar(15) NOT NULL default '',
              logintime datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              KEY userid (userid)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: IPtable</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: IPtable</td><td class=\"success\">success</td></tr>\n";
	}

	// Shouttabelle
	$query = "CREATE TABLE $shouttable (
              id mediumint(8) unsigned NOT NULL auto_increment,
              username varchar(40) NOT NULL default '',
              shouttext varchar(255) NOT NULL default '',
              shoutdate datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: shoutbox</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: shoutbox</td><td class=\"success\">success</td></tr>\n";
	}

	// Allianzgeschichte
	$query = "CREATE TABLE $allyhistory (
              alliance_id int(10) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              members smallint(5) unsigned NOT NULL default '0',
              PRIMARY KEY  (alliance_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allyhistory</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: allyhistory</td><td class=\"success\">success</td></tr>\n";
	}

	// Spielergeschichte
	$query = "CREATE TABLE $playerhistory (
              player_id int(10) unsigned NOT NULL default '0',
              alliance_id int(10) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              PRIMARY KEY  (player_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playerhistory</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: playerhistory</td><td class=\"success\">success</td></tr>\n";
	}



	// Player history - insert
	$query ="CREATE TRIGGER players_ai AFTER INSERT ON $playertable
  FOR EACH ROW BEGIN
    INSERT INTO $playerhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	player_id = NEW.id, 
    	alliance_id = NEW.alliance_id,    
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints;
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER players_au AFTER UPDATE ON $playertable
  FOR EACH ROW BEGIN
    INSERT INTO $playerhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	player_id = NEW.id, 
    	alliance_id = NEW.alliance_id,    
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints
	ON DUPLICATE KEY UPDATE 
		rank=valueS(rank), points=VALUES(points),
		frank=valueS(frank), fpoints=VALUES(fpoints),
		rrank=valueS(rrank), rpoints=VALUES(rpoints);    	
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $playertable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}
	// Ally history - insert
	$query ="CREATE TRIGGER alliances_ai AFTER INSERT ON $allytable
  FOR EACH ROW BEGIN
    INSERT INTO $allyhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	alliance_id = NEW.id,
    	members = NEW.members,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints;
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}
	// Ally history - update
	$query ="CREATE TRIGGER alliances_au AFTER UPDATE ON $allytable
  FOR EACH ROW BEGIN
    INSERT INTO $allyhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	alliance_id = NEW.id,
    	members = NEW.members,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints
	ON DUPLICATE KEY UPDATE
		rank=values(rank), points=values(points),
		frank=values(frank), fpoints=values(fpoints),
		rrank=values(rrank), rpoints=values(rpoints);	
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $allytable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER reports_ai AFTER INSERT ON $reporttable
 FOR EACH ROW BEGIN
 	IF NEW.scanned = 'research' OR NEW.computech > 0 OR NEW.energytech > 0 THEN
	    UPDATE $playertable SET 
	     spiolvl = NEW.spiolvl,
	     computech = NEW.computech,
	     waffentech = NEW.waffentech,
	     schildtech = NEW.schildtech,
	     rpz = NEW.rpz,
	     energytech = NEW.energytech,
	     hypertech = NEW.hypertech,
	     vbt = NEW.vbt,
	     impulse = NEW.impulse,
	     hra = NEW.hra,
	     lasertech = NEW.lasertech,
	     iontech = NEW.iontech,
	     plasmatech = NEW.plasmatech,
	     forschungsnetz = NEW.forschungsnetz,
	     expedition = NEW.expedition,
	     gravi = NEW.gravi
	     WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname LIMIT 1);
     END IF;
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 1)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 1)</td><td class=\"success\">success</td></tr>\n";
	}

	$query ="CREATE TRIGGER reports_au AFTER UPDATE ON $reporttable
 FOR EACH ROW BEGIN
 	IF NEW.scanned = 'research' OR NEW.computech > 0 OR NEW.energytech > 0 THEN
	    UPDATE $playertable SET 
	     spiolvl = NEW.spiolvl,
	     computech = NEW.computech,
	     waffentech = NEW.waffentech,
	     schildtech = NEW.schildtech,
	     rpz = NEW.rpz,
	     energytech = NEW.energytech,
	     hypertech = NEW.hypertech,
	     vbt = NEW.vbt,
	     impulse = NEW.impulse,
	     hra = NEW.hra,
	     lasertech = NEW.lasertech,
	     iontech = NEW.iontech,
	     plasmatech = NEW.plasmatech,
	     forschungsnetz = NEW.forschungsnetz,
	     expedition = NEW.expedition,
	     gravi = NEW.gravi
	     WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname  LIMIT 1);
	END IF;
  END";
	if (!mysql_query($query)) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 2)</td><td class=\"failure\">failure</td></tr>\n";
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">".mysql_error()."</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Table: $reporttable (Trigger 2)</td><td class=\"success\">success</td></tr>\n";
	}


	if (!$error_occured) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"success\" colspan=\"2\">Installation complete</td></tr>\n";
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\" class=\"failure\" colspan=\"2\">Installation failed</td></tr>\n";
	}
}
?>
</table>
</form>
</body>
</html>