<?php

class tab_plugin {

	/**
	 * This method prints out the HTML Code required for the tab_plugin.
	 * The css + js files must be loaded before (head tag)!
	 *
	 * @param Array $tab_array Associative multi array containing information about each tab.
	 * example: $tab_array[0]["name"] contains the tab text
	 *          $tab_array[0]["url"] contains the URL that shall be loaded when the tab is selected
	 *          $tab_array[0]["content"] contains the content that shall be shown when the tab is selected
	 */
	/* public static */ function create_tabs($tab_array) {

		echo '
		<div id="scroll_container" class="scroll_container" style="overflow: hidden;">
		<table id="scrolltab" cellpadding="0" cellspacing="0" border="0" class="tab_table" style="position:relative; left: 0px;" onmouseover="show_scrollbar_button()">
		<colgroup>
		<col width="1%" span="'.(count($tab_array)*2).'">
		</colgroup>
		<colgroup>
		<col width="99%">
		</colgroup>
		<tr class="tab_table_row">';

		for ($i = 0; $i < count($tab_array); $i++){
			if ($i == 0) {
				// active tab
				if (isset($tab_array[0]["url"])) {
					echo '<th class="tab_active" id="td_tab'.($i+1).'" nowrap onclick="show_tab(\''.($i+1).'\',\''.$tab_array[$i]["url"].'\');"><span class="tabtext">'.$tab_array[$i]["name"].'</span></th><th class="empty_table_header"><div id="corner_tab'.($i+1).'" class="tab_corner_active"></div></th>';
				} else {
					echo '<th class="tab_active" id="td_tab'.($i+1).'" nowrap onclick="show_tab(\''.($i+1).'\');"><span class="tabtext">'.$tab_array[$i]["name"].'</span></th><th class="empty_table_header"><div id="corner_tab'.($i+1).'" class="tab_corner_active"></div></th>';
				}
			} else {
				// inactive tabs
				if (isset($tab_array[$i]["url"])) {
					echo '<th class="tab_inactive" id="td_tab'.($i+1).'" nowrap onclick="show_tab(\''.($i+1).'\',\''.$tab_array[$i]["url"].'\');"><span class="tabtext">'.$tab_array[$i]["name"].'</span></th><th class="empty_table_header"><div id="corner_tab'.($i+1).'" class="tab_corner_inactive"></div></th>';
				} else {
					echo '<th class="tab_inactive" id="td_tab'.($i+1).'" nowrap onclick="show_tab(\''.($i+1).'\');"><span class="tabtext">'.$tab_array[$i]["name"].'</span></th><th class="empty_table_header"><div id="corner_tab'.($i+1).'" class="tab_corner_inactive"></div></th>';
				}
			}
		}

		echo '
		<th class="empty_table_header">&nbsp;</th>
		</tr>
		</table>
		<div id="scroll_buttons" class="scrollbuttons" style="z-index:999; position:absolute; left:0px; top:0px; display:none;">
		<a  id="scroll_left_button" href="#" onclick="scroll_left()" style="padding-left:4px;"><img src="../images/right.gif" border="0" /></a>
		<br />
		<a id="scroll_right_button" href="#" onclick="scroll_right()" style="padding-left:4px;"><img src="../images/left.gif" border="0" /></a>
		<br />
		<a id="scroll_down_button" href="#" onclick="scroll_menu()" style="padding-left:4px;"><img src="../images/down.gif" border="0" /></a>
		</div>
		<div id="scroll_menu" class="scrollmenu" style="z-index:999; position:absolute; top:0px; display:none;"></div>
		</div>
		<div id="tab_content" class="tab_content" style="overflow:auto;">';

		for ($i = 0; $i < count($tab_array); $i++){
			if ($i == 0) {
				// active tab
				if (isset($tab_array[0]["content"])) {
					echo '<div id="tab'.($i+1).'" style="display:inline;">'.$tab_array[0]["content"].'</div>'."\n";
				} else {
					exit("fatal exception: no URL must be specified at default tab");
				}
				echo "\n";
			} else {
				// inactive tabs
				if (isset($tab_array[$i]["url"])) {
					echo '<div id="tab'.($i+1).'" style="display:none;"></div>'."\n";
				} else {
					echo '<div id="tab'.($i+1).'" style="display:none;">'.$tab_array[$i]["content"].'</div>'."\n";
				}
				echo "\n";
			}

		}
		echo '
		</div>
		<div id="loading_tab" class="tab_content_loading_tab" style="display: none; position:absolute; z-index: 997; left: 0px; top: 0px;">&nbsp;</div>
		<div class="tab_content_loading" style="position:absolute; top:50px; left:10px; display: none; z-index: 998;" id="loading" ><img alt="loading..." src="../images/loading_small.gif" border="0" /> Loading...</div>
		';
	}




}




?>