/*
 *
 * Tab Plugin Javascripts
 * (c) 2005-2008 Christian Lehmann
 * mail: webmaster@mathe-informatik.de
 * www: http://www.galaxytool.eu
 *
 * Requires: advajax.js to load contents from external webpages
 *
 */

var current_tab                = "tab1";
var scrolled_tabs = 0; // stores the number of tabs that were scrolled to the left
var scrolled_px   = 0; // stores the amount of pixel that were scrolled to the left
var cached_tab_elements; // array contains all elements that are already loaded

function __select_tab(number) {
	var tab_id = "tab"+number;
	var tab_width = 0;
	try {
		// hide current information
		document.getElementById(current_tab).style.display = "none";

		// change picture settings
		document.getElementById("td_"+current_tab).setAttribute("class","tab_inactive");
		document.getElementById("corner_"+current_tab).setAttribute("class","tab_corner_inactive");

		// activate new tab
		document.getElementById("td_"+tab_id).setAttribute("class","tab_active");
		document.getElementById("corner_"+tab_id).setAttribute("class","tab_corner_active");

		// show new information
		document.getElementById(tab_id).style.display = "inline";
		current_tab = tab_id;

		// scroll tabs if currently selected tab cannot be displayed
		while(true) {
			// check if the currently selected tab is the tab on the left
			if (number == scrolled_tabs+1) {
				return;
			}

			var tab_width = 0;
			if (scrolled_tabs+1 <= number) {
				for (var i=scrolled_tabs+1; i<=number; i++) {
					tab_width += document.getElementById("td_tab"+i).offsetWidth;
					tab_width += document.getElementById("corner_tab"+i).offsetWidth;
				}
				if (tab_width <= document.getElementById("scroll_container").offsetWidth) {
					return;
				}
				// check if the tab is shown completely
				scroll_left();

			} else {
				for (var i=number; i<=scrolled_tabs; i++) {
					tab_width += document.getElementById("td_tab"+i).offsetWidth;
					tab_width += document.getElementById("corner_tab"+i).offsetWidth;
				}
				// check if the tab is shown completely
				scroll_right();
			}
		}

	} catch(e) {
		alert("error: "+e);
	}
}

function show_tab(number,source_url) {
	// disable loading animation (tab changed during load process)
	document.getElementById("loading_tab").style.display = "none";
	document.getElementById("loading").style.display = "none";

	if (source_url != null) {
		// fill content - TODO: check buffer
		fill_tab_content(number,source_url);
	}
	__select_tab(number);
	document.getElementById("scroll_menu").style.display = "none";
}

function scroll_left() {
	try {
		scrolled_tabs++;
		var scroll_px = 0;
		scroll_px = document.getElementById("td_tab"+scrolled_tabs).offsetWidth;
		scroll_px += document.getElementById("corner_tab"+scrolled_tabs).offsetWidth;

		scrolled_px -= scroll_px;
		document.getElementById("scrolltab").style.left = scrolled_px+"px";
	} catch(e) {
		scrolled_tabs--;
		return;
	}
}

function scroll_right() {
	try {
		var scroll_px = 0;

		scroll_px = document.getElementById("td_tab"+scrolled_tabs).offsetWidth;
		scroll_px += document.getElementById("corner_tab"+scrolled_tabs).offsetWidth;

		scrolled_px += scroll_px;
		document.getElementById("scrolltab").style.left = scrolled_px+"px";

		scrolled_tabs--;
	} catch(e) {
		return;
	}
}

function scroll_menu() {
	document.getElementById("scroll_menu").style.display="inline";
	// determine position from top
	document.getElementById("scroll_menu").style.top = document.getElementById("scroll_buttons").offsetTop
	+ document.getElementById("scroll_buttons").offsetHeight + "px";

	// fill link text
	var i = 1;
	var tabtext = "";
	document.getElementById("scroll_menu").innerHTML = "";
	var loop = true;
	var onclick_attribute = "";
	while(loop) {
		try {
			tab_text = document.getElementById("td_tab"+i).getElementsByTagName("span")[0].innerHTML;
			onclick_attribute = document.getElementById("td_tab"+i).getAttribute("onclick");

			document.getElementById("scroll_menu").innerHTML += "<div class=\"scrollmenuentry\"><a href=\"#\" class=\"scrollmenulink\" onclick=\""+onclick_attribute+"\">" + tab_text + "</a></div>";

			i++;
		} catch(e) {
			// we are done
			loop = false;
		}
	}

	document.getElementById("scroll_menu").style.left = document.getElementById("scroll_buttons").offsetLeft+"px";
}

function show_scrollbar_button() {
	if (document.getElementById("scrolltab").offsetWidth <= document.getElementById("scroll_container").offsetWidth) {
		return;
	}
	document.getElementById("scroll_buttons").style.top = document.getElementById("scrolltab").offsetTop+"px";

	document.getElementById("scroll_buttons").style.left = getAbsolutePosition(document.getElementById("scroll_container")).x
	+ document.getElementById("scroll_container").offsetWidth + "px";

	document.getElementById("scroll_buttons").style.display="inline";
}

function fill_tab_content(number,source_url) {
	// check if cache array is built up
	if (cached_tab_elements == null) {
		var i = 0;
		try {
			while(true) {
				i++;
				var tmp = document.getElementById("tab"+i).innerHTML;
			}
		} catch(e) {
			cached_tab_elements = new Array(i+1); // [0] won't be used here for direct access
		}
	}

	// check if the tab content was already loaded
	if (cached_tab_elements[number] == true) {
		return; // content already inside the container
	}



	// make a new div above the content box with 50% transparent
	document.getElementById("loading_tab").style.display = "inline";
	document.getElementById("loading_tab").style.top     = document.getElementById("tab_content").offsetTop + 2 + "px";
	document.getElementById("loading_tab").style.left    = getAbsolutePosition(document.getElementById("tab_content")).x + 1 + "px";

	// show loading icon
	document.getElementById("loading").style.display = "inline";
	document.getElementById("loading").style.top     = document.getElementById("tab_content").offsetTop + parseInt(document.getElementById("tab_content").offsetHeight / 2) + "px";
	document.getElementById("loading").style.left    = getAbsolutePosition(document.getElementById("tab_content")).x + parseInt(document.getElementById("tab_content").offsetWidth / 2) - parseInt(document.getElementById("loading").offsetWidth / 2) + "px";


	advAJAX.get({
		url : source_url,
		onSuccess : function(obj) {
			document.getElementById("tab"+number).innerHTML      = obj.responseText;
			document.getElementById("loading").style.display     = "none";
			document.getElementById("loading_tab").style.display = "none";
		},
		onError : function(obj) { alert("Error: " + obj.status); }
	});
	cached_tab_elements[number] = true;
}
