<?php
require "secret/version.php";
// config check
ob_start();
require "config/config.php";
$config_content = ob_get_contents();
ob_end_clean();
// attributes check
ob_start();
chdir('config');
require "attributes.php";
chdir('../');
$attributes_content = ob_get_contents();
ob_end_clean();

$error_occured = false;

?>

<?php
$version_array = array(
"200" => "2.0",
"222" => "2.2x",
"302" => "3.0-3.02",
"304" => "3.03-3.04",
"340" => "3.1-3.3",
"350" => "3.4-3.42",
"400" => "3.5-3.52",
"405" => "4.0-4.04",
"411" => "4.05-4.11",
"420" => "4.12",
"437" => "4.2-4.3.6",
"440" => "4.3.7",
"460" => "4.3.7-4.5.4"
);

if (!isset($_POST['version'])) {
?>
<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Update</title>
<link rel="stylesheet" type="text/css" href="secret/styles.css" />
</head>
<body>
<form action="update.php" method="POST" accept-charset="utf-8">
<table class="standard" cellpadding="0" cellspacing="0" border="0" style="margin-top:200px; width:250px;" align="center">
<tr class="firstcolor"><td colspan="2" align="center" class="tblhead">Galaxytool <?php echo VERSION; ?> - Update check</td></tr>
<?php

if (!empty($config_content)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: config.php</td><td class=\"success\">success</td></tr>\n";
}
if (!empty($attributes_content)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Syntax: attributes.php</td><td class=\"success\">success</td></tr>\n";
}
if (empty($owner)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Owner</td><td class=\"success\">$owner</td></tr>\n";
}
if (empty($default_language)) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Language</td><td class=\"success\">$default_language</td></tr>\n";
}
if (empty($global_universe) || (!is_numeric($global_universe) && preg_replace("/[a-zA-Z0-9_\-]/","",$global_universe) != "" )) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Universe</td><td class=\"success\">$global_universe</td></tr>\n";
}
if (!is_numeric($speed_rate) || $speed_rate <= 0) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"failure\">failed</td></tr>\n";
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Speedrate</td><td class=\"success\">$speed_rate</td></tr>\n";
}
$link = mysql_connect($dbhost, $dbusername, $dbpassword);
if (!$link) {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">failed</td></tr>\n";
	$error_occured = true;
} else {
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL connection</td><td class=\"success\">success</td></tr>\n";
	$db_selected = mysql_select_db($dbname, $link);
	if (!$db_selected) {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"failure\">failed</td></tr>\n";
		$error_occured = true;
	} else {
		echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">Database existency</td><td class=\"success\">success</td></tr>\n";

		$query = "SELECT VERSION() as version";
		$res = mysql_query($query) or die(mysql_error());
		$version = mysql_fetch_object($res);
		if (strpos($version->version,"-") > 0) {
			$version = substr($version->version,0,strpos($version->version,"-"));
		} else {
			$version = $version->version;
		}

		$subversion = explode(".",$version);
		if (!isset($subversion[0]) || $subversion[0] < 5) {
			echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
			$error_occured = true;
		} else {
			/*if ($subversion[0] == 4) {
				// MySQL 4.x.x
				if (!isset($subversion[1]) || $subversion[1] < 1) {
					echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
					$error_occured = true;
				} else {
					if (!isset($subversion[2]) || $subversion[2] < 16) {
						echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
						$error_occured = true;
					} else {
						// success
						echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
					}
				}
			} else*/ if ($subversion[0] == 5) {
				// MySQL 5.x.x
				// http://bugs.galaxytool.eu/view.php?id=375 <-- v5.0.87 has a bug
				if (!isset($subversion[1]) || !isset($subversion[2]) || ($subversion[1] == 0 && $subversion[2] < 16) || ($subversion[1] == 0 && $subversion[2] == 87)) {
					echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"failure\">$version</td></tr>\n";
					$error_occured = true;
				} else {
					// success
					echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
				}
			} elseif ($subversion[0] == 6) {
				// MySQL 6.x.x
				echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">MySQL version check</td><td class=\"success\">$version</td></tr>\n";
			}
		}
	}
}

if (substr(phpversion(),0,1) > 4) {
	$version = substr(phpversion(),0,strpos(phpversion(), '-'));
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"success\">$version</td></tr>\n";	
} else {
	$error_occured = true;
	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">PHP version check</td><td class=\"failure\">failed</td></tr>\n";	
}

//if (!empty($old_dbtablename) && $old_dbtablename != $dbtablename &&
//!empty($old_utablename)  && $old_utablename  != $utablename &&
//!empty($old_pstablename) && $old_pstablename != $playertable &&
//!empty($old_astablename) && $old_astablename != $allytable &&
//!empty($old_noticetable) && $old_noticetable != $noticetable &&
//!empty($old_reporttable) && $old_reporttable != $reporttable &&
//!empty($old_iptablename) && $old_iptablename != $iptablename &&
//!empty($old_shouttable)  && $old_shouttable  != $shouttable &&
//!empty($old_allyhistory) && $old_allyhistory != $allyhistory ) {
//
//	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">tablenames</td><td class=\"success\">success</td></tr>\n";
//} else {
//	echo "<tr class=\"firstcolor\"><td style=\"padding-left:10px;\">tablenames</td><td class=\"failure\">failure</td></tr>\n";
//	$error_occured = true;
//}

if (!$error_occured) {
	echo '
        <tr class="firstcolor"><td style="padding-left:10px; padding-top:10px;">Select your old Version:</td><td style="padding-top:10px;">
        <select class="pulldown_code" name="version">
        ';
	foreach ($version_array as $key => $text) {
		echo "<option value=\"$key\">$text</option>";
	}
	echo '
        </select></td></tr>
        <tr class="firstcolor"><td style="padding-left:10px; padding-top:10px;" align="center" colspan="2"><input class="button" type="submit" name="submit" value="submit" /></td></tr>
        </form>
        ';
} else {
	echo "<tr class=\"firstcolor\"><td colspan=\"2\" align=\"center\"><a class=\"link\" href=\"update.php\">Check again</a></td></tr>\n";
}

?>

</td></tr>
</table>
<?php
} else {
?>
<!doctype HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<title>Update</title>
<link rel="stylesheet" type="text/css" href="secret/styles.css" />
</head>
<body>
<div style="width:400px; color:#c4c4c4; background-color:#344566; padding-top:10px; padding-left:10px;">

<?php
ob_start();
require "config/config.php";
$content = ob_get_contents();
ob_end_clean();
if (!empty($content)) {
	$version = 999999;
	echo "Your config.php is not valid php Code!<br />";
}

$version = (int)$_POST['version'];
mysql_connect($dbhost,$dbusername,$dbpassword) or die(mysql_error());
mysql_select_db($dbname) or die(mysql_error());

// send feedback - do not stop if this fails
/*
about the feedback:
I collect information about the used MySQL version and PHP Version.
I am using this information to know which versions I can skip.
E.g. if only php5 would be used, I could use the php5 class system.
If MySQL 5 or above would be used, I could use new MySQL 5 features.
*/
$query = "SELECT VERSION() as version";
$res = mysql_query($query) or die(mysql_error());
$mysql_version = mysql_fetch_object($res);
$mysql_version = $mysql_version->version;
$fp = @fopen("http://www.galaxytool.eu/feedback.php?php_version=".substr(phpversion(),0,strpos(phpversion(), '-'))."&mysql_version=".substr($mysql_version,0,strpos($mysql_version, '-')),"r");
@fclose($fp);


if ($version <= 200) {
	echo "Updating from Version 2.0 ...<br />\n";
	// Update from 2.0 to version 2.2x
	$query = "ALTER TABLE $dbtablename ADD mondgr SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER mond ,
        ADD metall INT UNSIGNED DEFAULT '0' NOT NULL AFTER mondgr ,
        ADD kristall INT UNSIGNED DEFAULT '0' NOT NULL AFTER metall";
	mysql_query($query) or die(mysql_error());
	echo "33% done<br />\n";

	$query = "CREATE TABLE $pstablename (
        	playername VARCHAR( 30 ) NOT NULL ,
        	rank SMALLINT UNSIGNED DEFAULT '0' NOT NULL ,
        	last_update VARCHAR( 20 ) NOT NULL ,
        	PRIMARY KEY ( playername )
        	)";
	mysql_query($query) or die(mysql_error());
	echo "66% done<br />\n";

	$query = "CREATE TABLE $astablename (
        	allyname VARCHAR( 30 ) NOT NULL ,
        	rank SMALLINT UNSIGNED DEFAULT '0' NOT NULL ,
        	members SMALLINT UNSIGNED DEFAULT '0' NOT NULL ,
        	last_update VARCHAR( 20 ) NOT NULL ,
        	PRIMARY KEY ( allyname )
        	)";
	mysql_query($query) or die(mysql_error());
	echo "100% done<br />\n";
}

if ($version <= 222) {
	echo "Updating from Version 2.2x ...<br />\n";
	// Update from 2.2x to 3.0
	echo "Update of $dbtablename running (this may take some time!) ...<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename ADD coordinates varchar(9) NOT NULL default '' AFTER mond ,
          ADD notices enum('true','false') NOT NULL default 'false' AFTER userid ,
          ADD reports enum('true','false') NOT NULL default 'false' AFTER notices ";
	mysql_query($query) or die(mysql_error());
	echo "12,5% done<br />\n";
	flush();
	$query  = "UPDATE $dbtablename SET coordinates=CONCAT(galaxie,':',system,':',planet)";
	mysql_query($query) or die(mysql_error());
	echo "25% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename DROP INDEX galaxie";
	mysql_query($query) or die(mysql_error());
	echo "37,5% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename DROP INDEX system";
	mysql_query($query) or die(mysql_error());
	echo "50% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename DROP INDEX planet";
	mysql_query($query) or die(mysql_error());
	echo "62,5% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename ADD INDEX (spielername)";
	mysql_query($query) or die(mysql_error());
	echo "75% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename ADD INDEX (ally)";
	mysql_query($query) or die(mysql_error());
	echo "87,5% done<br />\n";
	flush();
	$query = "ALTER TABLE $dbtablename ADD INDEX (coordinates)";
	mysql_query($query) or die(mysql_error());
	echo "100% done<br />\n";
	flush();

	echo "Update of $utablename running...<br />\n";
	$query = "ALTER TABLE $utablename ADD stylepath varchar(255) NOT NULL default '' AFTER userpass";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "Create Table for notices...<br />\n";
	$query = "CREATE TABLE IF NOT EXISTS $noticetable (
          id int(11) NOT NULL auto_increment,
          userid smallint(6) NOT NULL default '0',
          public enum('true','false') NOT NULL default 'true',
          noticetext text NOT NULL,
          coordinates varchar(9) NOT NULL default '',
          timevalue varchar(20) NOT NULL default '',
          PRIMARY KEY  (id),
          UNIQUE KEY coordinates (coordinates,userid),
          KEY userid (userid),
          KEY public (public),
          KEY coordinates_2 (coordinates)
        )";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "Create Table for Reports...<br />\n";
	$query = "CREATE TABLE IF NOT EXISTS $reporttable (
          id int(10) unsigned NOT NULL auto_increment,
          coordinates varchar(9) NOT NULL default '',
          moon enum('true','false') NOT NULL default 'false',
          metal int(10) unsigned NOT NULL default '0',
          crystal int(10) unsigned NOT NULL default '0',
          deuterium int(10) unsigned NOT NULL default '0',
          energy int(10) unsigned NOT NULL default '0',
          kt mediumint(8) unsigned NOT NULL default '0',
          gt mediumint(8) unsigned NOT NULL default '0',
          lj mediumint(8) unsigned NOT NULL default '0',
          sj mediumint(8) unsigned NOT NULL default '0',
          krz mediumint(8) unsigned NOT NULL default '0',
          ss mediumint(8) unsigned NOT NULL default '0',
          kolo mediumint(8) unsigned NOT NULL default '0',
          rec mediumint(8) unsigned NOT NULL default '0',
          spio mediumint(8) unsigned NOT NULL default '0',
          bomb mediumint(8) unsigned NOT NULL default '0',
          zerri mediumint(8) unsigned NOT NULL default '0',
          ds mediumint(8) unsigned NOT NULL default '0',
          sat mediumint(8) unsigned NOT NULL default '0',
          rak mediumint(8) unsigned NOT NULL default '0',
          ll mediumint(8) unsigned NOT NULL default '0',
          sl mediumint(8) unsigned NOT NULL default '0',
          ion mediumint(8) unsigned NOT NULL default '0',
          gauss mediumint(8) unsigned NOT NULL default '0',
          plasma mediumint(8) unsigned NOT NULL default '0',
          ksk mediumint(8) unsigned NOT NULL default '0',
          gsk mediumint(8) unsigned NOT NULL default '0',
          arak mediumint(8) unsigned NOT NULL default '0',
          irak mediumint(8) unsigned NOT NULL default '0',
          memi tinyint(3) unsigned NOT NULL default '0',
          krimi tinyint(3) unsigned NOT NULL default '0',
          deutsyn tinyint(3) unsigned NOT NULL default '0',
          solar tinyint(3) unsigned NOT NULL default '0',
          fusion tinyint(3) unsigned NOT NULL default '0',
          robo tinyint(3) unsigned NOT NULL default '0',
          nani tinyint(3) unsigned NOT NULL default '0',
          rawe tinyint(3) unsigned NOT NULL default '0',
          mesp tinyint(3) unsigned NOT NULL default '0',
          krissp tinyint(3) unsigned NOT NULL default '0',
          deutsp tinyint(3) unsigned NOT NULL default '0',
          folab tinyint(3) unsigned NOT NULL default '0',
          allydep tinyint(3) unsigned NOT NULL default '0',
          raksilo tinyint(3) unsigned NOT NULL default '0',
          mbase tinyint(3) unsigned NOT NULL default '0',
          sensor tinyint(3) unsigned NOT NULL default '0',
          sprungtor tinyint(3) unsigned NOT NULL default '0',
          spiolvl tinyint(3) unsigned NOT NULL default '0',
          computech tinyint(3) unsigned NOT NULL default '0',
          waffentech tinyint(3) unsigned NOT NULL default '0',
          schildtech tinyint(3) unsigned NOT NULL default '0',
          rpz tinyint(3) unsigned NOT NULL default '0',
          energytech tinyint(3) unsigned NOT NULL default '0',
          hypertech tinyint(3) unsigned NOT NULL default '0',
          vbt tinyint(3) unsigned NOT NULL default '0',
          impulse tinyint(3) unsigned NOT NULL default '0',
          hra tinyint(3) unsigned NOT NULL default '0',
          lasertech tinyint(3) unsigned NOT NULL default '0',
          iontech tinyint(3) unsigned NOT NULL default '0',
          plasmatech tinyint(3) unsigned NOT NULL default '0',
          forschungsnetz tinyint(3) unsigned NOT NULL default '0',
          gravi tinyint(3) unsigned NOT NULL default '0',
          scantime varchar(14) NOT NULL default '',
          PRIMARY KEY  (id),
          UNIQUE KEY coordinates_2 (coordinates,moon)
        )";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
}

if ($version <= 302) {
	// Update from 3.0 bis 3.02 to 3.03
	echo "Updating from 3.0-3.02 to 3.03...<br />\n";
	$query = "ALTER TABLE $reporttable ADD terra TINYINT(3) UNSIGNED DEFAULT '0' NOT NULL AFTER folab";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
}

if ($version <= 304) {
	echo "Updating from Version 3.03 or 3.04 ...<br />\n";
	// Update from 3.04 to 3.1
	$query = "ALTER TABLE $reporttable ADD scanned ENUM( 'ressources', 'fleet', 'defence', 'buildings', 'research' ) DEFAULT 'ressources' NOT NULL AFTER scantime";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $reporttable SET scanned='fleet' where kt>'0' OR gt>'0' OR lj>'0' OR sj>'0' OR krz>'0' OR ss>'0' OR kolo>'0' OR rec>'0' OR spio>'0' OR bomb>'0' OR zerri>'0' OR ds>'0' OR sat>'0'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $reporttable SET scanned='defence' where rak>'0' OR ll>'0' OR sl>'0' OR ion>'0' OR gauss>'0' OR plasma>'0' OR ksk>'0' OR gsk>'0' OR arak>'0' OR irak>'0'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $reporttable SET scanned='buildings' where memi>'0' OR krimi>'0' OR deutsyn>'0' OR solar>'0' OR fusion>'0' OR robo>'0' OR nani>'0' OR rawe>'0' OR mesp>'0' OR krissp>'0' OR deutsp>'0' OR folab>'0' OR allydep>'0' OR raksilo>'0' OR mbase>'0' OR sensor>'0' OR sprungtor";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $reporttable SET scanned='research' where spiolvl>'0' OR computech>'0' OR waffentech>'0' OR schildtech>'0' OR rpz>'0' OR energytech>'0' OR hypertech>'0' OR vbt>'0' OR impulse>'0' OR hra>'0' OR lasertech>'0' OR iontech>'0' OR plasmatech>'0' OR forschungsnetz>'0' OR gravi>'0'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $astablename
        		  ADD allystatus ENUM( 'nap', 'ally', 'war', 'boycott', 'neutral', 'nothing', 'own', 'wing' ) DEFAULT 'nothing' NOT NULL AFTER members,
        		  ADD points INT UNSIGNED DEFAULT '0' NOT NULL AFTER rank ,
                  ADD frank SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER points ,
                  ADD fpoints INT UNSIGNED DEFAULT '0' NOT NULL AFTER frank ,
                  ADD rrank SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER fpoints ,
                  ADD rpoints INT UNSIGNED DEFAULT '0' NOT NULL AFTER rrank";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "TRUNCATE TABLE $pstablename";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $pstablename ADD points INT UNSIGNED DEFAULT '0' NOT NULL AFTER rank ,
                  ADD frank SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER points ,
                  ADD fpoints INT UNSIGNED DEFAULT '0' NOT NULL AFTER frank ,
                  ADD rrank SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER fpoints ,
                  ADD rpoints INT UNSIGNED DEFAULT '0' NOT NULL AFTER rrank,
                  ADD ogame_playerid INT UNSIGNED DEFAULT '0' NOT NULL AFTER playername";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $pstablename ADD UNIQUE (ogame_playerid)";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $utablename
        		  ADD probeview ENUM( 'true', 'false' ) DEFAULT 'false' NOT NULL AFTER statusview,
        		  ADD status ENUM( 'email', 'admin', 'active' ) DEFAULT 'email' NOT NULL AFTER userman,
        		  ADD email VARCHAR( 50 ) NOT NULL AFTER userpass ,
		          ADD ingame VARCHAR( 20 ) NOT NULL AFTER email,
		          ADD allytag VARCHAR( 10 ) NOT NULL AFTER ingame,
		          ADD logins SMALLINT UNSIGNED DEFAULT '0' NOT NULL AFTER status,
		          ADD lastlogin DATETIME NOT NULL AFTER logins
        		  ";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $utablename DROP styles";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $utablename SET probeview = 'true'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $utablename SET status = 'active'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "CREATE TABLE $iptablename (
		id INT UNSIGNED NOT NULL AUTO_INCREMENT ,
		userid SMALLINT UNSIGNED NOT NULL ,
		ip VARCHAR( 15 ) NOT NULL ,
		logintime DATETIME NOT NULL ,
		PRIMARY KEY ( id )
		)";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "CREATE TABLE $shouttable (
		id TINYINT UNSIGNED NOT NULL AUTO_INCREMENT ,
		username VARCHAR( 20 ) NOT NULL ,
		shouttext VARCHAR( 255 ) NOT NULL ,
		shoutdate DATETIME NOT NULL ,
		PRIMARY KEY ( id )
		)";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
}
if ($version <= 340) {
	echo "Updating from Version 3.1 or later ...<br />\n";
	// Update from 3.1 to 3.4
	$query = "ALTER TABLE $shouttable CHANGE id id MEDIUMINT UNSIGNED NOT NULL AUTO_INCREMENT";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $utablename ADD allyhistory ENUM( 'true', 'false' ) DEFAULT 'false' NOT NULL AFTER userman ;";
	mysql_query($query) or die(mysql_error());
	$query = "ALTER TABLE $utablename ADD diplomatic ENUM( 'true', 'false' ) DEFAULT 'false' NOT NULL AFTER allyhistory ;";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $utablename ADD ogame_playerid INT( 11 ) UNSIGNED NOT NULL AFTER userpass;";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "CREATE TABLE $allyhistory (
				  id int(10) unsigned NOT NULL auto_increment,
				  ogame_playerid int(11) unsigned NOT NULL default '0',
				  playername varchar(30) NOT NULL default '',
				  score int(11) unsigned NOT NULL default '0',
				  date_added date NOT NULL default '0000-00-00',
				  PRIMARY KEY  (id),
				  UNIQUE KEY ogame_playerid (ogame_playerid,date_added)
				)";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
}
if ($version <= 350) {

	$query = "ALTER TABLE $allyhistory ADD alliance VARCHAR(30) DEFAULT 'main' NOT NULL AFTER playername";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $reporttable ADD fleet_resis BIGINT UNSIGNED DEFAULT '0' NOT NULL AFTER gravi ,
			  ADD defence_resis BIGINT UNSIGNED DEFAULT '0' NOT NULL AFTER fleet_resis;";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $reporttable SET fleet_resis=(kt*4000 + gt*12000 + lj*4000 + sj*10000 + krz*27000 + ss*60000 + kolo*30000 + rec*30000 + spio*1000 + bomb*22500 + zerri*110000 + ds*9000000 + sat*2000),
	          defence_resis=(rak*600 + ll*600 + sl*2400 + ion*2400 + gauss*10500 + plasma*30000 + ksk*6000 + gsk*30000)";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $pstablename ADD ally VARCHAR( 30 ) NOT NULL AFTER playername";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $dbtablename SET mond='1' WHERE mond='t'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $dbtablename SET mond='0' WHERE mond='f'";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $dbtablename ADD ogame_playerid INT( 11 ) UNSIGNED NOT NULL DEFAULT '0' AFTER spielername";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $dbtablename ADD INDEX ( ogame_playerid )";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

}
if ($version <= 400) {
	// new table for galaxyview
	echo "create new galaxytable... ";
	$query = "CREATE TABLE ".$dbtablename." (
              galaxy int(2) NOT NULL default '0',
              system int(3) NOT NULL default '0',
              planet int(2) NOT NULL default '0',
              player_id smallint(5) unsigned NOT NULL default '0',
              moon enum('true','false') NOT NULL default 'false',
              moonsize smallint(5) unsigned NOT NULL default '0',
              metal int(10) unsigned NOT NULL default '0',
              crystal int(10) unsigned NOT NULL default '0',
              planetname varchar(20) NOT NULL default '',
              last_update datetime NOT NULL default '0000-00-00 00:00:00',
              user_id smallint(5) unsigned NOT NULL default '0',
              PRIMARY KEY  (galaxy,system,planet),
              KEY player_id (player_id)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new usertable... ";
	$query = "CREATE TABLE ".$utablename." (
              id smallint(10) unsigned NOT NULL auto_increment,
              username varchar(20) NOT NULL default '',
              userpass varchar(32) NOT NULL default '',
              ogame_playerid int(11) unsigned NOT NULL default '0',
              email varchar(50) NOT NULL default '',
              ingame varchar(20) NOT NULL default '',
              allytag varchar(10) NOT NULL default '',
              stylepath varchar(255) NOT NULL default '',
              cansearch enum('true','false') NOT NULL default 'false',
              caninsert enum('true','false') NOT NULL default 'false',
              statusview enum('true','false') NOT NULL default 'false',
              probeview enum('true','false') NOT NULL default 'false',
              userman enum('true','false') NOT NULL default 'false',
              allyhistory enum('true','false') NOT NULL default 'false',
              diplomatic enum('true','false') NOT NULL default 'false',
              status enum('email','admin','active') NOT NULL default 'email',
              logins smallint(5) unsigned NOT NULL default '0',
              lastlogin datetime NOT NULL default '0000-00-00 00:00:00',
              last_action datetime NOT NULL default '0000-00-00 00:00:00',
              statspage mediumint(8) unsigned NOT NULL default '100',
              links text NOT NULL,
              bb_coordinates varchar(25) NOT NULL default 'deeppink',
              bb_moon varchar(25) NOT NULL default 'burlywood',
              bb_debris varchar(25) NOT NULL default 'firebrick',
              bb_ally varchar(25) NOT NULL default 'tomato',
              bb_allydetails varchar(25) NOT NULL default 'coral',
              bb_playername varchar(25) NOT NULL default 'teal',
              bb_banned varchar(25) NOT NULL default 'red',
              bb_vacation varchar(25) NOT NULL default 'skyblue',
              bb_noob varchar(25) NOT NULL default 'limegreen',
              bb_inactive varchar(25) NOT NULL default 'silver',
              bb_longinactive varchar(25) NOT NULL default 'silver',
              PRIMARY KEY  (id),
              UNIQUE KEY username (username)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new playertable... ";
	$query = "CREATE TABLE $playertable (
              id smallint(5) unsigned NOT NULL auto_increment,
              playername varchar(30) NOT NULL default '',
              ogame_playerid int(11) unsigned default NULL,
              alliance_id smallint(5) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              last_stats_update datetime NOT NULL default '0000-00-00 00:00:00',
              noob enum('true','false') NOT NULL default 'false',
              banned enum('true','false') NOT NULL default 'false',
              vacation enum('true','false') NOT NULL default 'false',
              inactive enum('true','false') NOT NULL default 'false',
              long_inactive enum('true','false') NOT NULL default 'false',
              diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') NOT NULL default 'nothing',
              spiolvl tinyint(3) unsigned NOT NULL default '0',
              computech tinyint(3) unsigned NOT NULL default '0',
              waffentech tinyint(3) unsigned NOT NULL default '0',
              schildtech tinyint(3) unsigned NOT NULL default '0',
              rpz tinyint(3) unsigned NOT NULL default '0',
              energytech tinyint(3) unsigned NOT NULL default '0',
              hypertech tinyint(3) unsigned NOT NULL default '0',
              vbt tinyint(3) unsigned NOT NULL default '0',
              impulse tinyint(3) unsigned NOT NULL default '0',
              hra tinyint(3) unsigned NOT NULL default '0',
              lasertech tinyint(3) unsigned NOT NULL default '0',
              iontech tinyint(3) unsigned NOT NULL default '0',
              plasmatech tinyint(3) unsigned NOT NULL default '0',
              forschungsnetz tinyint(3) unsigned NOT NULL default '0',
              gravi tinyint(3) unsigned NOT NULL default '0',
              last_tech_update datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              UNIQUE KEY playername (playername),
              UNIQUE KEY ogame_playerid (ogame_playerid),
              KEY alliance_id (alliance_id),
              KEY noob (noob),
              KEY banned (banned),
              KEY vacation (vacation),
              KEY inactive (inactive)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new allytable... ";
	$query = "CREATE TABLE $allytable (
              id smallint(5) unsigned NOT NULL auto_increment,
              allyname varchar(30) default NULL,
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              members smallint(5) unsigned NOT NULL default '0',
              diplomatic_status enum('nap','ally','war','boycott','neutral','nothing','own','wing') default 'nothing',
              last_update datetime default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              UNIQUE KEY allyname (allyname),
              KEY last_update (last_update)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new noticetable... ";
	$query = "CREATE TABLE ".$noticetable." (
              id int(11) NOT NULL auto_increment,
              noticetext text NOT NULL,
              player_id smallint(5) unsigned NOT NULL default '0',
              last_update datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              UNIQUE KEY player_id (player_id)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new reporttable... ";
	$query = "CREATE TABLE ".$reporttable." (
              id int(10) unsigned NOT NULL auto_increment,
              galaxy int(2) unsigned NOT NULL default '0',
              system int(3) unsigned NOT NULL default '0',
              planet int(2) unsigned NOT NULL default '0',
              planetname varchar(20) NOT NULL default '',
              moon enum('true','false') NOT NULL default 'false',
              metal int(10) unsigned NOT NULL default '0',
              crystal int(10) unsigned NOT NULL default '0',
              deuterium int(10) unsigned NOT NULL default '0',
              energy int(10) unsigned NOT NULL default '0',
              kt mediumint(8) unsigned NOT NULL default '0',
              gt mediumint(8) unsigned NOT NULL default '0',
              lj mediumint(8) unsigned NOT NULL default '0',
              sj mediumint(8) unsigned NOT NULL default '0',
              krz mediumint(8) unsigned NOT NULL default '0',
              ss mediumint(8) unsigned NOT NULL default '0',
              kolo mediumint(8) unsigned NOT NULL default '0',
              rec mediumint(8) unsigned NOT NULL default '0',
              spio mediumint(8) unsigned NOT NULL default '0',
              bomb mediumint(8) unsigned NOT NULL default '0',
              zerri mediumint(8) unsigned NOT NULL default '0',
              ds mediumint(8) unsigned NOT NULL default '0',
              skrz mediumint(8) unsigned NOT NULL default '0',
              sat mediumint(8) unsigned NOT NULL default '0',
              rak mediumint(8) unsigned NOT NULL default '0',
              ll mediumint(8) unsigned NOT NULL default '0',
              sl mediumint(8) unsigned NOT NULL default '0',
              ion mediumint(8) unsigned NOT NULL default '0',
              gauss mediumint(8) unsigned NOT NULL default '0',
              plasma mediumint(8) unsigned NOT NULL default '0',
              ksk mediumint(8) unsigned NOT NULL default '0',
              gsk mediumint(8) unsigned NOT NULL default '0',
              arak mediumint(8) unsigned NOT NULL default '0',
              irak mediumint(8) unsigned NOT NULL default '0',
              memi tinyint(3) unsigned NOT NULL default '0',
              krimi tinyint(3) unsigned NOT NULL default '0',
              deutsyn tinyint(3) unsigned NOT NULL default '0',
              solar tinyint(3) unsigned NOT NULL default '0',
              fusion tinyint(3) unsigned NOT NULL default '0',
              robo tinyint(3) unsigned NOT NULL default '0',
              nani tinyint(3) unsigned NOT NULL default '0',
              rawe tinyint(3) unsigned NOT NULL default '0',
              mesp tinyint(3) unsigned NOT NULL default '0',
              krissp tinyint(3) unsigned NOT NULL default '0',
              deutsp tinyint(3) unsigned NOT NULL default '0',
              folab tinyint(3) unsigned NOT NULL default '0',
              terra tinyint(3) unsigned NOT NULL default '0',
              allydep tinyint(3) unsigned NOT NULL default '0',
              raksilo tinyint(3) unsigned NOT NULL default '0',
              mbase tinyint(3) unsigned NOT NULL default '0',
              sensor tinyint(3) unsigned NOT NULL default '0',
              sprungtor tinyint(3) unsigned NOT NULL default '0',
              spiolvl tinyint(3) unsigned NOT NULL default '0',
              computech tinyint(3) unsigned NOT NULL default '0',
              waffentech tinyint(3) unsigned NOT NULL default '0',
              schildtech tinyint(3) unsigned NOT NULL default '0',
              rpz tinyint(3) unsigned NOT NULL default '0',
              energytech tinyint(3) unsigned NOT NULL default '0',
              hypertech tinyint(3) unsigned NOT NULL default '0',
              vbt tinyint(3) unsigned NOT NULL default '0',
              impulse tinyint(3) unsigned NOT NULL default '0',
              hra tinyint(3) unsigned NOT NULL default '0',
              lasertech tinyint(3) unsigned NOT NULL default '0',
              iontech tinyint(3) unsigned NOT NULL default '0',
              plasmatech tinyint(3) unsigned NOT NULL default '0',
              forschungsnetz tinyint(3) unsigned NOT NULL default '0',
              gravi tinyint(3) unsigned NOT NULL default '0',
              fleet_resis bigint(20) unsigned NOT NULL default '0',
              defence_resis bigint(20) unsigned NOT NULL default '0',
              scantime varchar(14) NOT NULL default '',
              scanned enum('ressources','fleet','defence','buildings','research') NOT NULL default 'ressources',
              PRIMARY KEY  (id),
              UNIQUE KEY coordinates (galaxy,system,planet,moon)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new iptable... ";
	$query = "CREATE TABLE ".$iptablename." (
              id int(10) unsigned NOT NULL auto_increment,
              userid smallint(5) unsigned NOT NULL default '0',
              ip varchar(15) NOT NULL default '',
              logintime datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id),
              KEY userid (userid)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new shoutbox... ";
	$query = "CREATE TABLE ".$shouttable." (
              id mediumint(8) unsigned NOT NULL auto_increment,
              username varchar(20) NOT NULL default '',
              shouttext varchar(255) NOT NULL default '',
              shoutdate datetime NOT NULL default '0000-00-00 00:00:00',
              PRIMARY KEY  (id)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new allyhistorytable... ";
	$query = "CREATE TABLE ".$allyhistory." (
              alliance_id smallint(5) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              members smallint(5) unsigned NOT NULL default '0',
              PRIMARY KEY  (alliance_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "create new playerhistorytable... ";
	$query = "CREATE TABLE ".$playerhistory." (
              player_id smallint(5) unsigned NOT NULL default '0',
              alliance_id smallint(5) unsigned NOT NULL default '0',
              year smallint(5) unsigned NOT NULL default '0',
              month tinyint(3) unsigned NOT NULL default '0',
              day tinyint(3) unsigned NOT NULL default '0',
              rank smallint(5) unsigned NOT NULL default '0',
              points int(10) unsigned NOT NULL default '0',
              frank smallint(5) unsigned NOT NULL default '0',
              fpoints int(10) unsigned NOT NULL default '0',
              rrank smallint(5) unsigned NOT NULL default '0',
              rpoints int(10) unsigned NOT NULL default '0',
              PRIMARY KEY  (player_id,year,month,day)
            ) DEFAULT CHARSET=utf8";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	// now all tables are created - fill new tables with data from old tables
	// usertable
	echo "fill usertable... ";
	flush();
	$query = "INSERT LOW_PRIORITY INTO $utablename (id,username,userpass,ogame_playerid,email,ingame,allytag,stylepath,links,cansearch,caninsert,statusview,probeview,userman,allyhistory,diplomatic,status,logins,lastlogin) ".
	"SELECT id,username,userpass,ogame_playerid,email,ingame,allytag,stylepath,'Galaxytool;http://www.galaxytool.eu',cansearch,caninsert,statusview,probeview,userman,allyhistory,diplomatic,status,logins,lastlogin  FROM $old_dbname".".$old_utablename";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";



	// shoutbox
	echo "fill shoutbox... ";
	flush();
	$query = "INSERT LOW_PRIORITY INTO $shouttable SELECT * FROM $old_dbname".".$old_shouttable";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	// IP table
	echo "fill IP table... ";
	flush();
	$query = "INSERT LOW_PRIORITY INTO $iptablename SELECT * FROM $old_dbname".".$old_iptablename";
	mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	// reports
	echo "fill reporttable... ";
	flush();
	$query = "INSERT INTO $reporttable (galaxy,system,planet,moon,metal,crystal,deuterium,energy,".
	"kt,gt,lj,sj,krz,ss,kolo,rec,spio,bomb,zerri,ds,sat,".
	"rak,ll,sl,ion,gauss,plasma,ksk,gsk,arak,irak,memi,krimi,deutsyn,".
	"solar,fusion,robo,nani,rawe,mesp,krissp,deutsp,folab,terra,allydep,raksilo,mbase,sensor,sprungtor,spiolvl,".
	"computech,waffentech,schildtech,rpz,energytech,hypertech,vbt,impulse,hra,lasertech,iontech,plasmatech,forschungsnetz,gravi,".
	"fleet_resis,defence_resis,scantime,scanned) ".
	"SELECT substring(coordinates from 1 for (locate(':',coordinates)-1)) as galaxie,
            substring(coordinates from locate(':',coordinates)+1 for (locate(':',substring(coordinates, locate(':',coordinates)+1)))-1) as system,
            substring(coordinates FROM -3+locate(':',substring(coordinates, -3))) as planet,
            moon,metal,crystal,deuterium,energy,".
            "kt,gt,lj,sj,krz,ss,kolo,rec,spio,bomb,zerri,ds,sat,".
            "rak,ll,sl,ion,gauss,plasma,ksk,gsk,arak,irak,memi,krimi,deutsyn,".
            "solar,fusion,robo,nani,rawe,mesp,krissp,deutsp,folab,terra,allydep,raksilo,mbase,sensor,sprungtor,spiolvl,".
            "computech,waffentech,schildtech,rpz,energytech,hypertech,vbt,impulse,hra,lasertech,iontech,plasmatech,forschungsnetz,gravi,".
            "fleet_resis,defence_resis,scantime,scanned ".
            "FROM $old_dbname".".$old_reporttable";
            mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            // allynames
            echo "fill allytable... ";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $allytable (allyname) ".
            "SELECT distinct(ally) FROM $old_dbname".".$old_dbtablename";
            mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            // playernames
            echo "fill playertable... ";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $playertable (playername,ogame_playerid) ".
            "SELECT distinct(spielername),ogame_playerid FROM $old_dbname".".$old_dbtablename WHERE ogame_playerid > 0 GROUP BY ogame_playerid HAVING max(zeit)";
            $res = mysql_query($query) or die(mysql_error());
            echo "done1, \n";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $playertable (playername) ".
            "SELECT distinct(spielername) FROM $old_dbname".".$old_dbtablename WHERE ogame_playerid = 0 ".
            "ON DUPLICATE KEY UPDATE playername=VALUES(playername)";
            $res = mysql_query($query) or die(mysql_error());
            echo "done2<br />\n";

            // galaxyview
            echo "get galaxydata... ";
            flush();
            $query = "SELECT ogt.*,a.id as alliance_id, p.id as player_id FROM ".
            " $old_dbname".".$old_dbtablename ogt, $allytable a, $playertable p ".
            " WHERE ogt.ally = a.allyname AND ogt.spielername = p.playername AND ogt.planet > 0 AND ogt.planet < 16".
            " ORDER BY last_update ASC"; // oldest first
            $res = mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            echo "fill galaxytable.";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $dbtablename (galaxy,system,planet,player_id,moon,moonsize,metal,crystal,planetname) VALUES ";
            $playerarray = array();
            $i = 0;
            while ($line = mysql_fetch_object($res)) {
            	if (trim($line->spielername) != '') {
            		$playerarray[$line->player_id]["alliance_id"]    = $line->alliance_id;
            		$playerarray[$line->player_id]["ogame_playerid"] = $line->ogame_playerid;
            		$playerarray[$line->player_id]["banned"]         = (strpos($line->status,"g") !== false) ? 'true' : 'false';
            		$playerarray[$line->player_id]["vacation"]       = (strpos($line->status,"u") !== false) ? 'true' : 'false';
            		$playerarray[$line->player_id]["noob"]           = (strpos($line->status,"n") !== false) ? 'true' : 'false';
            		$playerarray[$line->player_id]["inactive"]       = (strpos($line->status,"i") !== false) ? 'true' : 'false';
            		$playerarray[$line->player_id]["long_inactive"]  = (strpos($line->status,"I") !== false) ? 'true' : 'false';
            	}

            	$moon = ($line->mond == 1) ? 'true' : 'false';
            	$query .= "('".$line->galaxie."','".$line->system."','".$line->planet."','".$line->player_id."','".$moon."','".$line->mondgr."','".$line->metall."','".$line->kristall."','".$line->planetname."'),";

            	if ($i == 1000) {
            		// send data
            		$query = substr($query,0,strlen($query)-1);
            		mysql_query($query) or die($query."<br>".mysql_error());
            		echo ".";
            		flush();
            		// reset data
            		$i = 0;
            		$query = "INSERT LOW_PRIORITY INTO $dbtablename (galaxy,system,planet,player_id,moon,moonsize,metal,crystal,planetname) VALUES ";
            	}
            	$i++;
            }
            // send data
            if (strlen($query) > strlen("INSERT LOW_PRIORITY INTO $dbtablename (galaxy,system,planet,player_id,moon,moonsize,metal,crystal,planetname) VALUES ")) {
            	$query = substr($query,0,strlen($query)-1);
            	$res = mysql_query($query) or die(mysql_error());
            }
            echo "done<br />\n";

            // update playerdata
            echo "update playerdata... ";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $playertable (id,alliance_id,ogame_playerid,noob,banned,vacation,inactive,long_inactive) VALUES ";
            foreach ($playerarray as $playerid => $value) {
            	if ($value['ogame_playerid'] == 0) $value['ogame_playerid'] = 'NULL';
            	$query .= "('$playerid','".$value['alliance_id']."','".$value['ogame_playerid']."','".$value['noob']."','".$value['banned']."','".$value['vacation']."','".$value['inactive']."','".$value['long_inactive']."'),";
            }
            $query = substr($query,0,strlen($query)-1);
            if (strlen($query) > strlen("INSERT LOW_PRIORITY INTO $playertable (id,alliance_id,ogame_playerid,noob,banned,vacation,inactive,long_inactive) VALUES ")) {
            	$query .= " ON DUPLICATE KEY UPDATE alliance_id=VALUES(alliance_id),noob=VALUES(noob),banned=VALUES(banned),vacation=VALUES(vacation),inactive=VALUES(inactive),long_inactive=VALUES(long_inactive)";
            	// ogame playerid must not be updated, or duplicate key problems may occur
            	$res = mysql_query($query) or die(mysql_error());
            }
            echo "done<br />\n";

            // playerstats
            echo "fill playerstats... ";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $playertable (rank,points,frank,fpoints,rrank,rpoints,playername) ".
            "SELECT rank,points,frank,fpoints,rrank,rpoints,playername FROM $old_dbname".".$old_pstablename ".
            "ON DUPLICATE KEY UPDATE rank=VALUES(rank),points=VALUES(points),frank=VALUES(frank),fpoints=VALUES(fpoints),rrank=VALUES(rrank),rpoints=VALUES(rpoints),playername=VALUES(playername)";
            $res = mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            // allystats
            echo "fill allystats... ";
            flush();
            $query = "INSERT LOW_PRIORITY INTO $allytable (allyname,rank,points,frank,fpoints,rrank,rpoints,members,diplomatic_status) ".
            "SELECT allyname,rank,points,frank,fpoints,rrank,rpoints,members,allystatus as diplomatic_status FROM $old_dbname".".$old_astablename ".
            "ON DUPLICATE KEY UPDATE allyname=VALUES(allyname),rank=VALUES(rank),points=VALUES(points),frank=VALUES(frank),fpoints=VALUES(fpoints),rrank=VALUES(rrank),rpoints=VALUES(rpoints),members=VALUES(members),diplomatic_status=VALUES(diplomatic_status)";
            $res = mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            // set alliance diplomatic status for players too
            echo "set diplomatic status... ";
            flush();
            $query = "SELECT diplomatic_status,id FROM $allytable WHERE diplomatic_status != 'nothing'";
            $res = mysql_query($query) or die(mysql_error());
            while ($line = mysql_fetch_object($res)) {
            	$query2 = "UPDATE $playertable SET diplomatic_status='".$line->diplomatic_status."' WHERE alliance_id='".$line->id."'";
            	mysql_query($query) or die(mysql_error());
            }
            echo "done<br />\n";

            // insert allyhistory
            echo "fill player + allyhistory... ";
            flush();
            $query = "SELECT ah.*, a.id as alliance_id, p.id as player_id FROM $allytable a, $old_dbname".".$old_allyhistory ah, $playertable p WHERE a.allyname=ah.alliance AND p.playername=ah.playername ORDER BY date_added";
            $res = mysql_query($query) or die(mysql_error());
            $query2 = "INSERT LOW_PRIORITY INTO $playerhistory (player_id,alliance_id,year,month,day,points) VALUES ";
            $query3 = "INSERT LOW_PRIORITY INTO $allyhistory (alliance_id,year,month,day,points) VALUES ";
            $last_date_added = "";
            while ($line = mysql_fetch_object($res)) {
            	// store alliance
            	if ($line->date_added != $last_date_added) {
            		if (isset($allyarray) && count($allyarray) > 0) {
            			// add to query
            			foreach ($allyarray as $allyid => $allyscore) {
            				$query3 .= "($allyid,".substr($line->date_added,0,4).",".substr($line->date_added,5,2).",".substr($line->date_added,8,2).",$allyscore),";
            			}
            		}
            		// reset data
            		$allyarray = array();
            		$last_date_added = $line->date_added;
            	}

            	if (!isset($allyarray[$line->alliance_id])) $allyarray[$line->alliance_id] = $line->score;
            	else $allyarray[$line->alliance_id] += $line->score;

            	$query2 .= "($line->player_id,$line->alliance_id,".substr($line->date_added,0,4).",".substr($line->date_added,5,2).",".substr($line->date_added,8,2).",$line->score),";
            }
            if (strlen($query2) > strlen("INSERT LOW_PRIORITY INTO $playerhistory (player_id,alliance_id,year,month,day,points) VALUES ")) {
            	$query2 = substr($query2,0,strlen($query2)-1);
            	mysql_query($query2) or die(mysql_error());
            }
            echo "done\n";
            if (strlen($query3) > strlen("INSERT LOW_PRIORITY INTO $allyhistory (alliance_id,year,month,day,points) VALUES ")) {
            	$query3 = substr($query3,0,strlen($query3)-1);
            	mysql_query($query3) or die(mysql_error());
            }
            echo "done<br />\n";

            // get "blank" player
            echo "starting cleanup...";
            flush();
            $query = "SELECT id FROM $playertable WHERE playername=''";
            $res = mysql_query($query) or die(mysql_error());
            $line = mysql_fetch_object($res);
            $empty_player = '0';
            while ($line = mysql_fetch_object($res)) {
            	$empty_player = $line->id;
            }

            // delete them at galaxytable
            $query = "UPDATE $dbtablename SET player_id='0' WHERE player_id='$empty_player'";
            mysql_query($query) or die(mysql_error());

            // delete them at player and alliance table
            $query = "DELETE FROM $playertable WHERE id='$empty_player'";
            $res = mysql_query($query) or die(mysql_error());
            $query = "DELETE FROM $allytable WHERE allyname=''";
            $res = mysql_query($query) or die(mysql_error());


            // change key for playername from unique to index
            $query = "ALTER TABLE $playertable DROP INDEX playername , ADD INDEX playername ( playername )";
            $res = mysql_query($query) or die(mysql_error());
            echo "done<br />\n";


            echo "add some indices...";
            flush();
            // add new indices
            $query = "ALTER TABLE $allytable ADD INDEX (diplomatic_status) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $allytable ADD INDEX (rank) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $dbtablename ADD INDEX (moon)";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $dbtablename ADD INDEX (last_update) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $dbtablename ADD INDEX (metal) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $dbtablename ADD INDEX (crystal) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $playertable ADD INDEX (rank) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $playertable ADD INDEX (frank) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $utablename ADD INDEX (last_action) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $reporttable ADD INDEX (scantime)";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $reporttable ADD INDEX (metal) ";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $reporttable ADD INDEX (crystal)";
            $res = mysql_query($query) or die(mysql_error());
            $query = "ALTER TABLE $reporttable ADD INDEX (deuterium)";
            $res = mysql_query($query) or die(mysql_error());
            echo "done<br />\n";

            // Updateinstruktionen:
            // Allyhistory: Namen der Allianz muss mit dem richtigen Allynamen übereinstimmen - nicht "Wing" oder "main" !!!
}

if ($version <= 405) {
	// next version with DB update
	$query = "ALTER TABLE $utablename ADD INDEX (ingame)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $utablename ADD INDEX (ogame_playerid)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $playertable ADD INDEX (last_stats_update)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable ADD min_phalanx INT( 3 ) UNSIGNED NULL ,
				ADD max_phalanx INT( 3 ) UNSIGNED NULL ,
				ADD min_rak INT( 3 ) UNSIGNED NULL ,
				ADD max_rak INT( 3 ) UNSIGNED NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $reporttable ADD INDEX min_rak (galaxy,min_rak)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "ALTER TABLE $reporttable ADD INDEX min_phalanx (galaxy,min_phalanx)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $reporttable SET min_rak=(system - ((impulse*2)-1)), max_rak=(system + ((impulse*2)+1)) WHERE raksilo>3";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	$query = "UPDATE $reporttable SET min_phalanx=(system - ((sensor*sensor)-1)), max_phalanx=(system + ((sensor*sensor)-1)) WHERE sensor>0";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $dbtablename CHANGE planetname planetname VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

}
if ($version <= 411) {
	$query = "ALTER TABLE $dbtablename ADD INDEX ( planet )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable ADD expedition TINYINT( 3 ) UNSIGNED NOT NULL DEFAULT '0' COMMENT 'Expedition technology' AFTER forschungsnetz";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
}
if ($version <= 420) {
	$query = "ALTER TABLE $utablename ADD timezone_offset VARCHAR( 6 ) NOT NULL DEFAULT '+00:00' AFTER allytag";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable ADD user_id SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '0' AFTER scantime";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playertable ADD user_id SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '0' AFTER last_stats_update";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $allytable ADD user_id SMALLINT( 5 ) UNSIGNED NOT NULL DEFAULT '0' AFTER last_update";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable ADD INDEX ( user_id )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $utablename ADD is_admin ENUM( 'true', 'false' ) NOT NULL DEFAULT 'false' AFTER stylepath";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $utablename ADD INDEX ( is_admin )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "update $utablename set is_admin = 'true' where username = 'admin'";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	// if no admin account was found - create a new one
	if (mysql_affected_rows() == 0) {
		$query = "INSERT INTO $utablename
		  (username, userpass, stylepath, is_admin, cansearch, caninsert, statusview, probeview, userman, allyhistory, diplomatic, status, links) VALUES
		  ('admin', md5('galatool'),'styles.css', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'true', 'active', 'Galaxytool;http://www.galaxytool.eu')";
		$res = mysql_query($query) or die(mysql_error());
		echo "<span style=\"color:red;\">New adminuser (username: admin) created - change password! (default: galatool)</span><br />\n";
	}

	$query = "ALTER TABLE $playertable ADD expedition TINYINT UNSIGNED NOT NULL DEFAULT '0' AFTER forschungsnetz";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	// calculate min and max rak with new formula (0.78c)
	$query = "UPDATE $reporttable SET min_rak=(system - ((impulse*5)-1)), max_rak=(system + ((impulse*5)-1)) WHERE raksilo > 3";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";


}
if ($version <= 437) {
	// new version
	// in some versions this index is also there
	$query = "ALTER TABLE $dbtablename DROP INDEX moon_2";
	$res = mysql_query($query); // no die() here
	echo "done<br />\n";

	$query = "ALTER TABLE $utablename ADD session_save TEXT NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	echo "Update complete.";
	echo "</div>";
}

if ($version <= 440) {
	$query = "ALTER TABLE $dbtablename CHANGE planetname planetname VARCHAR(40) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playertable CHANGE playername playername VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $allytable CHANGE allyname allyname VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable CHANGE planetname planetname VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $utablename CHANGE username username VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $utablename CHANGE ingame ingame VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $utablename CHANGE allytag allytag VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $shouttable CHANGE username username VARCHAR( 40 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = " ALTER TABLE $playertable ADD INDEX ( diplomatic_status )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

}


if ($version <= 460) {
	
	// create a dummy trigger to check permissions before running the update
	$query = "DROP TRIGGER IF EXISTS galaxytool_dummy";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER galaxytool_dummy AFTER INSERT ON $playertable
	FOR EACH ROW BEGIN
	INSERT INTO $playerhistory SET
	year = DATE_FORMAT(NOW(),'%Y');
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	$query = "DROP TRIGGER galaxytool_dummy";
	mysql_query($query) or die($query." - ".mysql_error());
	
	// now start with real update
	
	$query = "ALTER TABLE $allytable CHANGE id id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT ";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playertable CHANGE id id INT( 10 ) UNSIGNED NOT NULL AUTO_INCREMENT ";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playertable CHANGE alliance_id alliance_id INT( 10 ) UNSIGNED NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	
	$query = "ALTER TABLE $playerhistory CHANGE player_id player_id INT( 10 ) UNSIGNED NOT NULL;";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playerhistory CHANGE alliance_id alliance_id INT( 10 ) UNSIGNED NOT NULL;";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $allyhistory CHANGE alliance_id alliance_id INT( 10 ) UNSIGNED NOT NULL;";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	
	$query = "ALTER TABLE $noticetable CHANGE player_id player_id INT( 10 ) UNSIGNED NOT NULL;";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $dbtablename CHANGE player_id player_id INT( 10 ) UNSIGNED NOT NULL;";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	
	$query = "ALTER TABLE $utablename ADD new_password enum('true','false') NOT NULL default 'true' AFTER userpass"; // default true to avoid that we have to adjust coding
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $utablename SET new_password='false'";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
		
	$query = "ALTER TABLE $allytable ADD ogame_allyid INT( 11 ) UNSIGNED NULL DEFAULT NULL AFTER id";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $allytable ADD UNIQUE ( ogame_allyid )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $playertable ADD homegalaxy INT( 2 ) UNSIGNED NOT NULL COMMENT 'Home coordinates' AFTER user_id ,
	ADD homesystem INT( 3 ) UNSIGNED NOT NULL COMMENT 'Home coordinates' AFTER homegalaxy ,
	ADD homeplanet INT( 2 ) UNSIGNED NOT NULL COMMENT 'Home coordinates' AFTER homesystem";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $reporttable CHANGE scantime scantime VARCHAR( 19 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "UPDATE $reporttable
	set scantime = concat(CONCAT(YEAR(CURDATE()),'.'),replace(scantime, '-','.'))
	where scantime != '' AND LEFT(scantime,5) != CONCAT(YEAR(CURDATE()),'.') AND CONVERT(LEFT(scantime,2), UNSIGNED) <= CONVERT(MONTH(CURDATE()), UNSIGNED) AND CONVERT(SUBSTR(scantime,4,2), UNSIGNED) <= CONVERT(DAY(CURDATE()), UNSIGNED)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";
	
	$query = "UPDATE $reporttable
	set scantime = concat(CONCAT(YEAR(CURDATE())-1,'.'),replace(scantime, '-','.'))
	where scantime != '' AND LEFT(scantime,5) != CONCAT(YEAR(CURDATE()),'.') AND CONVERT(LEFT(scantime,2), UNSIGNED) > CONVERT(MONTH(CURDATE()), UNSIGNED) OR CONVERT(SUBSTR(scantime,4,2), UNSIGNED) > CONVERT(DAY(CURDATE()), UNSIGNED)";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";

	$query = "ALTER TABLE $allytable DROP INDEX allyname, ADD INDEX allyname ( allyname )";
	$res = mysql_query($query) or die(mysql_error());
	echo "done<br />\n";


	// Trigger
	// Player history - insert
	$query = "DROP TRIGGER IF EXISTS players_ai";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER players_ai AFTER INSERT ON $playertable
	FOR EACH ROW BEGIN
	INSERT INTO $playerhistory SET
	year = DATE_FORMAT(NOW(),'%Y'),
	month = DATE_FORMAT(NOW(),'%m'),
	day = DATE_FORMAT(NOW(),'%e'),
	player_id = NEW.id,
	alliance_id = NEW.alliance_id,
	rank = NEW.rank,
	points = NEW.points,
	frank = NEW.frank,
	fpoints = NEW.fpoints,
	rrank = NEW.rrank,
	rpoints = NEW.rpoints;
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";

	// playerhistory - update
	$query = "DROP TRIGGER IF EXISTS players_au";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER players_au AFTER UPDATE ON $playertable
	FOR EACH ROW BEGIN
    INSERT INTO $playerhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	player_id = NEW.id, 
    	alliance_id = NEW.alliance_id,    
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints
	ON DUPLICATE KEY UPDATE 
		rank=valueS(rank), points=VALUES(points),
		frank=valueS(frank), fpoints=VALUES(fpoints),
		rrank=valueS(rrank), rpoints=VALUES(rpoints);
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";

	// Ally history - insert
	$query = "DROP TRIGGER IF EXISTS alliances_ai";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER alliances_ai AFTER INSERT ON $allytable
	FOR EACH ROW BEGIN
	INSERT INTO $allyhistory SET
	year = DATE_FORMAT(NOW(),'%Y'),
	month = DATE_FORMAT(NOW(),'%m'),
	day = DATE_FORMAT(NOW(),'%e'),
	alliance_id = NEW.id,
	members = NEW.members,
	rank = NEW.rank,
	points = NEW.points,
	frank = NEW.frank,
	fpoints = NEW.fpoints,
	rrank = NEW.rrank,
	rpoints = NEW.rpoints;
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";

	// Ally history - update
	$query = "DROP TRIGGER IF EXISTS alliances_au";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER alliances_au AFTER UPDATE ON $allytable
	FOR EACH ROW BEGIN
    INSERT INTO $allyhistory SET 
    	year = DATE_FORMAT(NOW(),'%Y'),
    	month = DATE_FORMAT(NOW(),'%m'),
    	day = DATE_FORMAT(NOW(),'%e'),
    	alliance_id = NEW.id,
    	members = NEW.members,
    	rank = NEW.rank,
    	points = NEW.points,
    	frank = NEW.frank,
    	fpoints = NEW.fpoints,
    	rrank = NEW.rrank,
    	rpoints = NEW.rpoints
	ON DUPLICATE KEY UPDATE
		rank=values(rank), points=values(points),
		frank=values(frank), fpoints=values(fpoints),
		rrank=values(rrank), rpoints=values(rpoints);
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";

	$query = "DROP TRIGGER IF EXISTS reports_ai";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER reports_ai AFTER INSERT ON $reporttable
	FOR EACH ROW BEGIN
	IF NEW.scanned = 'research' THEN
	UPDATE $playertable SET
	spiolvl = NEW.spiolvl,
	computech = NEW.computech,
	waffentech = NEW.waffentech,
	schildtech = NEW.schildtech,
	rpz = NEW.rpz,
	energytech = NEW.energytech,
	hypertech = NEW.hypertech,
	vbt = NEW.vbt,
	impulse = NEW.impulse,
	hra = NEW.hra,
	lasertech = NEW.lasertech,
	iontech = NEW.iontech,
	plasmatech = NEW.plasmatech,
	forschungsnetz = NEW.forschungsnetz,
	expedition = NEW.expedition,
	gravi = NEW.gravi
	WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname LIMIT 1);
	END IF;
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";
	
	$query = "DROP TRIGGER IF EXISTS reports_au";
	mysql_query($query) or die($query." - ".mysql_error());
	$query ="CREATE TRIGGER reports_au AFTER UPDATE ON $reporttable
	FOR EACH ROW BEGIN
	IF NEW.scanned = 'research' THEN
	UPDATE $playertable SET
	spiolvl = NEW.spiolvl,
	computech = NEW.computech,
	waffentech = NEW.waffentech,
	schildtech = NEW.schildtech,
	rpz = NEW.rpz,
	energytech = NEW.energytech,
	hypertech = NEW.hypertech,
	vbt = NEW.vbt,
	impulse = NEW.impulse,
	hra = NEW.hra,
	lasertech = NEW.lasertech,
	iontech = NEW.iontech,
	plasmatech = NEW.plasmatech,
	forschungsnetz = NEW.forschungsnetz,
	expedition = NEW.expedition,
	gravi = NEW.gravi
	WHERE id = (SELECT g.player_id FROM $reporttable r, $dbtablename g WHERE r.galaxy = g.galaxy AND r.system = g.system AND r.planet = g.planet AND r.planetname = g.planetname AND r.galaxy=NEW.galaxy AND r.system=NEW.system and r.planet=NEW.planet AND r.planetname=NEW.planetname LIMIT 1);
	END IF;
	END";
	mysql_query($query) or die($query." - ".mysql_error());
	echo "done<br />\n";	
}

}
?>
</body>
</html>